//+------------------------------------------------------------------+
//|  DEMO - Last Edit: August 27, 2014     00sd Average Joe-Demo.mq4 |
//|  For Downloads and Information, please follow the Link below.    |
//+------------------------------------------------------------------+
#property copyright " 2014 apipshort"
#property link "http://www.forexfactory.com/showthread.php?t=389386"
#property indicator_separate_window

#property version "1.0"
#property description "DEMO - Last Edit: August 25, 2014"
#property description " "
#property description "This demo uses 00sd Mu.mq4 as a base to show how an additional Average"
#property description "SD and Z-Score can be calculated for the standard 9 TF outlay found on MT4."
#property description " "
#property description "With an Average SMA, Price Deviation, SD and Z-score a useful set of"
#property description "market statistics now describes a symbolic Average Time Frame (Mu TF)."
#property description " "
#property description "No average time duration is calculated, but that is actually close to 3.14 Days."
#property description "For this reason the Mu TF data is found between the W1 and D1 TFs in Dash Board."

#property indicator_maximum  1
#property indicator_minimum  0
#property strict

extern string       m1 = "     Set SMA Period equal to BB system!"; // Make Sure
extern string       m2 = "     Simple MA Period = 20"; // Default Setting
extern int   smaPeriod = 20;      // SMA Period
extern string       m3 = "     Mu Settings"; // ==>
extern color     clrMu = clrDodgerBlue; // Color Mu Line
extern bool      muRay = false;   // Show Mu Line Across Chart
extern int       width = 1;       // Width Mu and SMA Lines
extern bool   showSMAs = false;   // Show TF SMA Lines and Price Levels
extern string       m4 = "     Options"; //  ==>
extern bool   showData = true;    // Show Dash Board
extern bool    comment = true;    // Show Comment
extern bool    tradeOn = false;   // Tally Running Pips
extern string       m5 = "     Dark Screen = 1, Light = 2"; // ==>
extern int     colorBG = 1;       // Choice of Back Ground
extern string       m6 = "     Label Settings"; //==>
extern string     font = "Arial"; // Label Font
extern int    fontSize = 10;      // Label Font Size
extern int      corner = 1;       // Chart Mu Labels in Corner

string tf[9] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int   per[9] = {PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,
      PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};

// row labels
string rowText[7] = {" ", "SMA", "Price Dev", "SD", "Z Score", "Z High", "Z Low"};
// TF data
double tfSMA[9],  tfSD[9];
double tfDev[9],   tfZ[9];
double tfZHi[9], tfZLo[9];

double mu, muDev, muSD, muZ, muOpen; // mu values
double meanZ, meanZHi, meanZLo;      // mean values from TFs
double zBarClose, zBarHi, zBarLo;    // z bar price values for display
double avBarHi, avBarLo, avBarOpen;  // average price bar
double zAvHi, zAvLo;                 // average price bar z-scores
double xPoint, priceOpen;            // display pips, tally

string pref  = "joe_";       // delete graphics
string padding;              // offset for display
int devLine = 27, grid = 14; // muDev line on-bar, length SD grid
int margin = 22, jump = 75;  // label display
int lengthMu = 100, space;   // length Mu line
int winID;

// colors for 9 TF SMA lines, best on Dark BG
color col[9] = {clrGray, clrGreen, clrDeepSkyBlue, clrRed, clrLightSeaGreen,
                clrDarkViolet, clrTomato, clrAqua, clrHotPink};

color clrUp, clrDwn, clrNoBias;
color clrBold, clrData, clrX;
color clrSD, clrZ, clrMuZ;

//+------------------------------------------------------------------+

void SetColors(int backGround)
   {
   switch (backGround)
      {
      case 1: clrUp= clrLime; clrDwn= clrCrimson; clrNoBias = clrDarkGray;
              clrBold= clrTan; clrSD= clrTeal; clrData= clrDarkGray; return;

      case 2: clrUp= clrLimeGreen; clrDwn= clrCrimson; clrNoBias = clrGray;
              clrBold= clrBlue; clrSD= clrBlue; clrData= clrBlack; return;

      default:     return;
      }
   } // end void SetColors(int backGround)

//+------------------------------------------------------------------+

int init()
   {
   //if found label "00z_SMA" read SMA Period from there
   int getSMA = StrToInteger(ObjectDescription("00z_SMA"));
   if(getSMA > 2) smaPeriod = getSMA;

   //if found label "00z_BG" read BG selection from there
   int getBG = StrToInteger(ObjectDescription("00z_BG"));
   if(getBG > 0) colorBG = getBG;
   if(colorBG < 1 || colorBG > 2) colorBG = 1;
   SetColors(colorBG);

   xPoint = Point;
   if(Digits==5||Digits==3) {xPoint = Point * 10;}
   if(Digits==2) {xPoint = Point * 100;}

   for (int i=0; i<=8 ;i++) {if(per[i] == Period()) rowText[0] = tf[i];}
   space = fontSize * 2;
   muOpen = 0;

   padding = "                            "; // adjust as fit
   //........"............................"; place holder only

   IndicatorShortName("Average Joe");

   return(0);
   } // end int init()

//+------------------------------------------------------------------+

int deinit()
   {
   Clear(pref, 0);
   if (comment) Comment("");

   return(0);
   } // end int deinit()

//+------------------------------------------------------------------+

int start()
   {
   if(winID < 1)
      {
      winID = WindowFind("Average Joe");
      priceOpen = Bid;
      }

   GetData();
   SetChartDisplay();
   ShowMuData();
   SetZBar();
   SetAverageBar();
   showDashboard();
   if(tradeOn) TradeOn();

   return(0);
   } // end start()

//+------------------------------------------------------------------+

void GetData()
   {
   int i;
   double sumSMA = 0, sumZ = 0, sumZHi = 0, sumZLo = 0;
   for(i=0; i<=8 ;i++)
      {
      tfSMA[i] =     iMA(NULL, per[i], smaPeriod, 0,MODE_SMA,PRICE_CLOSE, 0);
      tfSD[i]  = iStdDev(NULL, per[i], smaPeriod, 0,MODE_SMA,PRICE_CLOSE, 0);
      tfDev[i] = Bid - tfSMA[i];
      tfZ[i]   = tfDev[i] / tfSD[i];
      tfZHi[i] = (iHigh(NULL, per[i], 0) - tfSMA[i])/ tfSD[i];
      tfZLo[i] =  (iLow(NULL, per[i], 0) - tfSMA[i])/ tfSD[i];

      sumSMA += tfSMA[i];
      sumZ   +=   tfZ[i];
      sumZHi += tfZHi[i];
      sumZLo += tfZLo[i];
      }
   // averaging for mu and the mean z-scores on the 9 TFs
   mu      = sumSMA / 9;
   meanZ   = sumZ   / 9;
   meanZHi = sumZHi / 9;
   meanZLo = sumZLo / 9;

   muDev = Bid - mu; // simplification
   if(muOpen == 0) muOpen = mu; // track mu moves
   double muMove = mu - muOpen;

//-------Complete SD Calculation for the 9 TF Distribution-----------+

   // sum the squared price deviations (tfDev[i]) in each TF
   // divide the sum of squares by N=9 to get the Variance
   // the Standard Deviation (muSD) is the Square Root of Variance
   // the division of muDev by muSD gives the z-score; muZ

   double sumSqTfDev = 0;
   for(i=0; i<=8 ;i++)
      {
      sumSqTfDev += MathPow(tfDev[i], 2);
      }
   muSD = MathSqrt((sumSqTfDev / 9));
   muZ = muDev / muSD;

//-----------------------End SD Calculation--------------------------+

   // values for the Z Bar
   zBarClose = (meanZ   * muSD) + mu; // reverse from z-score
   zBarHi    = (meanZHi * muSD) + mu; // to price value for display
   zBarLo    = (meanZLo * muSD) + mu;

   // average price bar
   double sumAvBarHi = 0; double sumAvBarLo = 0; double sumAvBarOpen = 0;
   for(i=0; i<=8 ;i++)
      {
      sumAvBarHi   += iHigh(NULL, per[i], 0);
      sumAvBarLo   +=  iLow(NULL, per[i], 0);
      sumAvBarOpen += iOpen(NULL, per[i], 0);
      }
   // average for price points
   avBarHi   = sumAvBarHi / 9;
   avBarLo   = sumAvBarLo / 9;
   avBarOpen = sumAvBarOpen / 9;
   //z-scores on the average bar
   zAvHi = (avBarHi - mu) / muSD;
   zAvLo = (avBarLo - mu) / muSD;

   if(comment) Comment("SMA ", smaPeriod, "  Mu ", DoubleToStr(mu, Digits+1), "  muOpen ",
      DoubleToStr(muOpen, Digits+1), "  muMove ", GetSign(muMove), DoubleToStr(muMove/xPoint, 2));

   return;
   } // end void GetData()

//+------------------------------------------------------------------+

void SetChartDisplay()
   {
   // set muZ and meanZ z-score colors
   bool noBias;
   if((meanZ < muZ && meanZ > 0) || (meanZ > muZ && meanZ < 0))
      {noBias = true;} else {noBias = false;}

   if(noBias) {clrZ = clrNoBias;}
   if(!noBias && meanZ > 0) {clrZ = clrUp;}
   if(!noBias && meanZ < 0) {clrZ = clrDwn;}
   if(muZ >= 0) {clrMuZ = clrUp;} else {clrMuZ = clrDwn;}

   // various muSD level lines & info boxes
   double sd1Hi = mu + muSD;
   double sd1Lo = mu - muSD;
   double sd2Hi = mu + (muSD * 2);
   double sd2Lo = mu - (muSD * 2);

   TrendLine("SD+1", 0, grid, sd1Hi, sd1Hi, clrSD, 2, 0, false, true);
   TrendLine("SD-1", 0, grid, sd1Lo, sd1Lo, clrSD, 2, 0, false, true);
   TrendLine("SD+2", 0, grid, sd2Hi, sd2Hi, clrSD, 3, 0, false, true);
   TrendLine("SD-2", 0, grid, sd2Lo, sd2Lo, clrSD, 3, 0, false, true);

   TextBox("sd +1", grid, sd1Hi, "+1", fontSize, font, clrSD);
   TextBox("sd -1", grid, sd1Lo, "-1", fontSize, font, clrSD);
   TextBox("sd +2", grid, sd2Hi, "+2", fontSize, font, clrSD);
   TextBox("sd -2", grid, sd2Lo, "-2", fontSize, font, clrSD);

   // mu lines
   string obj = StringConcatenate("mu ", smaPeriod, " SMA");
   TrendLine(obj, 0, lengthMu, mu, mu, clrMu, 0, width, muRay, true);
   TrendLine("mu_tag", 0, 1, muOpen, muOpen, clrMu, 2, width, false, false);
   TrendLine("mu_Dev", devLine, devLine, mu, Bid, clrData, 2, 0, false, true);
   obj = StringConcatenate("last_bar = ", smaPeriod);
   Arrow(obj, smaPeriod, iLow(NULL, 0, smaPeriod), 115, 2, clrMu, true, 0);

   // display values: muDev
   string text = StringConcatenate(GetSign(muDev), DoubleToStr(muDev / xPoint, 0), "  muDev");
   TextBox("muDev", devLine - 4, mu + (muDev / 2), text, fontSize+1, font, clrMuZ);
   // muZ
   text = StringConcatenate( "muZ  ", GetSign(muZ), DoubleToStr(muZ, 2));
   TextBox("muZ", devLine + 3, Bid, text, fontSize+1, font, clrMuZ);
   // muSD
   text = StringConcatenate( "muSD  ", DoubleToStr((muSD / xPoint), 0));
   TextBox("muSD", devLine + 8, mu + (muDev / 2), text, fontSize+1, font, clrBold);

// show all 9 TF SMAs
   for(int i=0; i<=8 ;i++)
      {
      obj = StringConcatenate(tf[i], "_line");
      if(showSMAs)
         { // show all TF SMAs
         TrendLine(obj, 1, 0, tfSMA[i], tfSMA[i], col[i], 0, width, false, true);
         obj =  StringConcatenate(tf[i], "_price");
         text = StringConcatenate(padding, DoubleToStr(tfSMA[i], Digits-1), "  ", tf[i]);
         TextBox(obj, 0, tfSMA[i], text, fontSize, font, col[i]);
         }
         else {Arrow(obj, 0, tfSMA[i], 4, 2, col[i], false, ANCHOR_TOP);
         } // end if(showSMAs)
      } // end for(int i=0

   return;
   } // end void SetChartDisplay()

//+------------------------------------------------------------------+

void ShowMuData()
   {
   // 6 labels for MU statistics
   color clrOpen; int y = space; // vertical label spacing
   if(muDev < 0) {clrOpen = clrDwn;} else {clrOpen = clrUp;}

   // tf & sma period info
   string text = StringConcatenate(rowText[0], " ", smaPeriod, " sma");
   Label("sma_0", 0, 15, y, corner, text, fontSize, font, clrBold);

   y += space; // bid
   text = StringConcatenate("Bid  ", DoubleToStr(Bid, Digits-1));
   Label("bid_0", 0, 15, y, corner, text, fontSize, font, clrBold);

   y += space; // mu
   text = StringConcatenate("Mu  ",DoubleToStr(mu, Digits-1));
   Label("mu_0", 0, 15, y, corner, text, fontSize, font, clrBold);

   y += space; // muDev
   text = StringConcatenate("Dev   ", GetSign(muDev), DoubleToStr(muDev/xPoint, 1));
   Label("muDev_0", 0, 15, y, corner, text, fontSize, font, clrOpen);

   y += space; // muSD
   text = StringConcatenate( "muSD  ", DoubleToStr((muSD/xPoint), 1));
   Label("muSD_0", 0, 15, y, corner, text, fontSize, font,  clrBold);

   y += space; // muZ
   text = StringConcatenate( "muZ  ", GetSign(muZ), DoubleToStr(muZ, 2));
   Label("muZ_0", 0, 15, y, corner, text, fontSize, font, clrMuZ);

   return;
   }
//+------------------------------------------------------------------+

void SetZBar()
   {
   TrendLine("z_body", 0, 0, zBarHi, zBarLo, Teal,  0, 3, false, false);
   TrendLine("z_open", 0, 1, zBarClose, zBarClose, clrZ, 0, 3, false, false);
   TrendLine("lever", devLine, 0, Bid, zBarClose, clrData, 2, 0, true, true);

   string text = StringConcatenate(padding, GetSign(meanZ), DoubleToStr(meanZ, 2), "  Z");
   TextBox("meanZ", 0, zBarClose, text, fontSize+1, font, clrZ);

   text = DoubleToStr((zBarHi - zBarLo) / xPoint, 0);
   TextBox("zPips", 1, zBarHi, text, fontSize-2, font, clrData);

   return;
   } // end void SetZBar()

//+------------------------------------------------------------------+

void SetAverageBar()
   {
   TrendLine("av_body", 5, 5, avBarHi, avBarLo, HotPink,  0, 3, false, false);
   TrendLine("av_open", 6, 5, avBarOpen, avBarOpen, HotPink, 0, 3, false, false);

   string text = DoubleToStr((avBarHi - avBarLo) / xPoint, 0);
   TextBox("avPips", 6, avBarHi , text, fontSize-2, font, clrData);

   return;
   } // end void SetAverageBar()

//+------------------------------------------------------------------+

void TradeOn()
   { // tally from line & show pips
   double move = Bid - priceOpen; color clrOpen;
   if(move < 0) {clrOpen = clrDwn;} else {clrOpen = clrUp;}
   TrendLine("zero", 0, devLine, priceOpen, priceOpen, clrGreen, 2, 1, true, false);

   string text = StringConcatenate(GetSign(move), DoubleToStr(move/xPoint, 1));
   TextBox("P_L", 3, zBarClose, text, fontSize, font, clrOpen);

   return;
   } // end void TradeOn()

//+------------------------------------------------------------------+

void showDashboard()
   {
   clrX = clrBold;
   Label("period", winID, jump   + margin, 5, 0, StringConcatenate(smaPeriod," sma"), fontSize, font, clrX);
   Label("symbol", winID, jump*2 + margin, 5, 0, Symbol(), fontSize, font, clrX);
   Label("bid_1",  winID, jump*3 + margin, 5, 0, DoubleToStr(Bid, Digits-1), fontSize, font, clrX);

   if(showData)
      {
      // 1 column, row labels
      int i;
      for(i=0; i<=6; i++) {SetLabels(rowText[i]);}

      // MN, W1
      clrX = clrData;
      for(i=8; i>=7; i--) {SetLabels(tf[i]); LoadLabels(i);}

      //Mu TF
      clrX = clrBold;
      SetLabels("Mu TF");
      SetLabels(DoubleToStr(mu, Digits-1));
      clrX = clrMuZ;
      SetLabels(StringConcatenate(GetSign(muDev), DoubleToStr(muDev/xPoint, 1)));
      clrX = clrBold;
      SetLabels(StringConcatenate("  ", DoubleToStr(muSD/xPoint, 1)));
      clrX = clrMuZ;
      SetLabels(StringConcatenate(GetSign(muZ),DoubleToStr(muZ, 4)));
      clrX = clrBold;
      SetLabels(StringConcatenate(GetSign(zAvHi),DoubleToStr(zAvHi, 4)));
      SetLabels(StringConcatenate(GetSign(zAvLo),DoubleToStr(zAvLo, 4)));

      // D1 - M1
      clrX = clrData;
      for(i=6; i>=0; i--) {SetLabels(tf[i]); LoadLabels(i);}

      // TF Means
      clrX = clrBold;
      SetLabels("TF Means");
      SetLabels(DoubleToStr(mu, Digits-1));
      clrX = clrMuZ;
      SetLabels(StringConcatenate(GetSign(muDev), DoubleToStr(muDev/xPoint, 1)));
      SetLabels("");
      clrX = clrZ;
      SetLabels(StringConcatenate(GetSign(meanZ), DoubleToStr(meanZ, 4)));
      clrX = clrBold;
      SetLabels(StringConcatenate(GetSign(meanZHi), DoubleToStr(meanZHi, 4)));
      SetLabels(StringConcatenate(GetSign(meanZLo), DoubleToStr(meanZLo, 4)));
      } // end if(showData)

   return;
   } // end void showDashboard()

//+------------------------------------------------------------------+

void LoadLabels(int i)
   {
   SetLabels(DoubleToStr(tfSMA[i], Digits-1));
   SetLabels(StringConcatenate(GetSign(tfDev[i]), DoubleToStr(tfDev[i]/xPoint, 1)));
   SetLabels(StringConcatenate("  ",               DoubleToStr(tfSD[i]/xPoint, 1)));
   SetLabels(StringConcatenate(GetSign(tfZ[i]),   DoubleToStr(tfZ[i], 4)));
   SetLabels(StringConcatenate(GetSign(tfZHi[i]), DoubleToStr(tfZHi[i], 4)));
   SetLabels(StringConcatenate(GetSign(tfZLo[i]), DoubleToStr(tfZLo[i], 4)));

   return;
   } // end void LoadLabels(int i)

//+------------------------------------------------------------------+

void SetLabels(string data)
   {// show information, optional
   static int d = 0; // label ID
   static int k = 0;
   static int x = margin;
   static int y = 25;

   string obj = StringConcatenate("data_", d);
   Label(obj, winID, x, y, 0, data, fontSize, font, clrX);

   d++; k++;
   y += fontSize * 2;

   if(k == 2 || k == 5) y += fontSize * 2;
   if(d % 7 == 0)  {x += jump; y = 25; k = 0;}
   if(d % 84 == 0) {d = 0; x = margin; y = 25; k = 0;}

   if(!showData && d >= 1) {d = 0; x = margin; y = 25; k = 0; }

   return;
   } // end void SetLabels(string data)

//+-----------------------------SUPPORT------------------------------+

void Label(string obj, int win, int x, int y, int corn, string text, int size, string afont, color clr)
   {
   obj = StringConcatenate(pref, obj);
   if(!ObjectCreate(obj, OBJ_LABEL, win,0,0))   ObjectCreate(obj, OBJ_LABEL, win,0,0);
      if(!ObjectSet(obj, OBJPROP_XDISTANCE, x))    ObjectSet(obj, OBJPROP_XDISTANCE, x);
      if(!ObjectSet(obj, OBJPROP_YDISTANCE, y))    ObjectSet(obj, OBJPROP_YDISTANCE, y);
      if(!ObjectSet(obj, OBJPROP_CORNER, corn))    ObjectSet(obj, OBJPROP_CORNER, corn);
   if(!ObjectSetText(obj, text, size, afont, clr)) ObjectSetText(obj, text, size, afont, clr);

   return;
   }// end void Label(

//+------------------------------------------------------------------+

void TrendLine(string obj, int t1, int t2, double p1, double p2, color clr, int st, int w, bool ray, bool back)
   {
   obj = StringConcatenate(pref, obj);
   if(!ObjectCreate(obj, OBJ_TREND,0,0,0,0,0))  ObjectCreate(obj, OBJ_TREND,0,0,0,0,0);
      if(!ObjectSet(obj, OBJPROP_TIME1, Time[t1])) ObjectSet(obj, OBJPROP_TIME1, Time[t1]);
      if(!ObjectSet(obj, OBJPROP_TIME2, Time[t2])) ObjectSet(obj, OBJPROP_TIME2, Time[t2]);
      if(!ObjectSet(obj, OBJPROP_PRICE1, p1))      ObjectSet(obj, OBJPROP_PRICE1, p1);
      if(!ObjectSet(obj, OBJPROP_PRICE2, p2))      ObjectSet(obj, OBJPROP_PRICE2, p2);
      if(!ObjectSet(obj, OBJPROP_COLOR,  clr))     ObjectSet(obj, OBJPROP_COLOR,  clr);
      if(!ObjectSet(obj, OBJPROP_STYLE,  st))      ObjectSet(obj, OBJPROP_STYLE,  st);
      if(!ObjectSet(obj, OBJPROP_WIDTH,  w))       ObjectSet(obj, OBJPROP_WIDTH,  w);
      if(!ObjectSet(obj, OBJPROP_RAY,    ray))     ObjectSet(obj, OBJPROP_RAY,    ray);
      if(!ObjectSet(obj, OBJPROP_BACK,   back))    ObjectSet(obj, OBJPROP_BACK,   back);

   return;
   }// end void TrendLine(

//+------------------------------------------------------------------+

void TextBox(string obj, int t1, double p1, string text, int size, string afont, color clr)
   {
   obj = StringConcatenate(pref, obj);
   if (!ObjectCreate(obj, OBJ_TEXT, 0,0,0,0))    ObjectCreate(obj, OBJ_TEXT, 0,0,0,0);
       if(!ObjectSet(obj, OBJPROP_TIME1, Time[t1])) ObjectSet(obj, OBJPROP_TIME1, Time[t1]);
       if(!ObjectSet(obj, OBJPROP_PRICE1, p1))      ObjectSet(obj, OBJPROP_PRICE1, p1);
   if(!ObjectSetText(obj, text, size, afont, clr)) ObjectSetText(obj, text, size, afont, clr);

   return;
   }// end void TextBox(

//+------------------------------------------------------------------+

void Arrow(string obj, int t1, double p1, int code, int wide, color clr, bool back, int anchr)
   {
   obj = StringConcatenate(pref, obj);
   if(!ObjectCreate(obj, OBJ_ARROW, 0,0,0,0))   ObjectCreate(obj, OBJ_ARROW, 0,0,0,0);
      if(!ObjectSet(obj, OBJPROP_TIME1, Time[t1])) ObjectSet(obj, OBJPROP_TIME1, Time[t1]);
      if(!ObjectSet(obj, OBJPROP_PRICE1, p1))      ObjectSet(obj, OBJPROP_PRICE1, p1);
      if(!ObjectSet(obj, OBJPROP_ARROWCODE, code)) ObjectSet(obj, OBJPROP_ARROWCODE, code);
      if(!ObjectSet(obj, OBJPROP_WIDTH, wide))     ObjectSet(obj, OBJPROP_WIDTH, wide);
      if(!ObjectSet(obj, OBJPROP_COLOR, clr))      ObjectSet(obj, OBJPROP_COLOR, clr);
      if(!ObjectSet(obj, OBJPROP_BACK,  back))     ObjectSet(obj, OBJPROP_BACK,  back);
      if(!ObjectSet(obj, OBJPROP_ANCHOR, anchr))   ObjectSet(obj, OBJPROP_ANCHOR, anchr);

   return;
   }// end void Arrow(

//+------------------------------------------------------------------+

string GetSign(double in)
   {
   string sign;
   if (in <= 0) {sign = " ";} else {sign = "+";}
   return(sign);
   } // end string GetSign(double in)

//+------------------------------------------------------------------+

void Clear(string findMe, int startFrom)
   {
   string name;
   int obj_total = ObjectsTotal();
   for (int i=obj_total-1; i>=0; i--)
      {
       name = ObjectName(i);
       if (StringFind(name, findMe) == startFrom) ObjectDelete(name);
      }
   return;
   } // end void Clear(string findMe, int startFrom)

//+-----------------------------EOP----------------------------------+
